Module NullableDemo

    Sub Main()
        Dim locObj As Object
        Dim locNullOfInt As Integer? = Nothing

        'Es gibt natrlich eine verwendbare Instanz, denn
        'Integer? ist ein Wertetyp!
        Console.WriteLine("Hat locNullOfInt einen Wert: " & locNullOfInt.HasValue)

        'Und dennoch ergibt das folgende Konstrukt True,
        'als wrde locObj keine Referenz haben!
        locObj = locNullOfInt
        Console.WriteLine("Ist locObj Nothing? " & (locObj Is Nothing).ToString)
        Console.WriteLine()

        'Und auch das "Entboxen" geht!
        'Es gibt keine Null-Exception!
        locNullOfInt = DirectCast(locObj, Integer?)

        'Und geht das dann auch? - Natrlich!
        locNullOfInt = DirectCast(Nothing, Integer?)

        'Und noch weiter. Wir boxen einen Integer?
        locNullOfInt = 10
        '
        locObj = locNullOfInt
        Dim locInt As Integer = DirectCast(locObj, Integer)

        Console.WriteLine("Taste drcken zum Beenden!")
        Console.ReadKey()

        'Das geht brigens nicht, obwohl Nullable die 
        'Contraits-Einschrnkung im  Grunde genommen erfllt!
        'Dim locNullOfInt As Nullable(Of Integer?)
    End Sub
End Module
