﻿Module ConcurrencyCheck

    Sub main()
        ' Neuen DataContext anlegen
        Dim datacontext As New AdventureWorksDataContext

        ' Sämtliche SQL-Kommandos auf Console.Out ausgeben
        datacontext.Log = Console.Out

        Dim electronicBikeRepair = (From lieferant In datacontext.Vendors _
                                  Where lieferant.Name = "Electronic Bike Repair & Supplies").First

        electronicBikeRepair.CreditRating += CByte(1)

        Console.WriteLine()
        Console.WriteLine("Verwenden Sie das Management Studio und führen folgendes Update aus:")
        Console.WriteLine("update AdventureWorks.Purchasing.Vendor")
        Console.WriteLine("set CreditRating=CreditRating+1,")
        Console.WriteLine("ModifiedDate = GETDATE()")
        Console.WriteLine("where Name = 'Electronic Bike Repair & Supplies'")
        Console.WriteLine("Ist diesese erfolgt, drücken Sie bitte Return. Sie werden eine Fehlermeldung erhalten.")
        Console.ReadKey()

        datacontext.SubmitChanges()
        ' die folgenden Zeilen werden nur ausgeführt, falls das Update nicht durchgeführt wurde.
        Console.WriteLine("Die Änderungen wurden gespeichert. Bitte Return drücken, um Programm zu beenden.")
        Console.ReadKey()

    End Sub

End Module
