﻿'Diese Codedatei hat natürlich nichts mit LINQ to Entities zu tun.
'Der Autor benötigte sie nur, um einer Kollegin bei Microsoft,
'die zum Zeitpunkt sehr viel Stress auf der TechEd in Barcelona
'hatte, nochmal einige Minuten ihrer wertvollen Zeit für
'das Überarbeiten des Vorworts stehlen zu können... ;-)

Public Interface NeedForPreface
    Property UrgencyLevel() As UrgencyLevels
End Interface

Public Interface PrefaceProvider
    Property ProvideDate() As Date
End Interface

Public Enum UrgencyLevels
    Low
    Medium
    MustHaveOtherwiseTypeSetterGonnaKillWritingEntity
    TypeSetterKillsWritingEntity
End Enum

Public Class Lisa
    Implements PrefaceProvider

    Private myProvideDate As Date

    Public Property ProvideDate() As Date Implements PrefaceProvider.ProvideDate
        Get
            Return myProvideDate
        End Get
        Set(ByVal value As Date)
            myProvideDate = value
        End Set
    End Property
End Class

Public MustInherit Class Klaus
    Implements NeedForPreface, IDisposable

    Const LastDateForPreface As Date = #11/12/2008#

    Sub New()
        If Now = LastDateForPreface Then
            Me.UrgencyLevel = UrgencyLevels.MustHaveOtherwiseTypeSetterGonnaKillWritingEntity
        ElseIf Now > LastDateForPreface Then
            Me.UrgencyLevel = UrgencyLevels.TypeSetterKillsWritingEntity
        End If
    End Sub

    Public Sub CallbackByTypeSetter()
        If Me.UrgencyLevel = UrgencyLevels.TypeSetterKillsWritingEntity Then
            Me.Dispose()
        End If
    End Sub

    Public MustOverride Property UrgencyLevel() As UrgencyLevels Implements NeedForPreface.UrgencyLevel

    Private disposedValue As Boolean = False

    ' IDisposable
    Protected Overridable Sub Dispose(ByVal disposing As Boolean)
        If Not Me.disposedValue Then
            If disposing Then
                ' TODO: Anderen Zustand freigeben (verwaltete Objekte).
            End If

            ' TODO: Eigenen Zustand freigeben (nicht verwaltete Objekte).
            ' TODO: Große Felder auf NULL festlegen.
        End If
        Me.disposedValue = True
    End Sub

#Region " IDisposable Support "
    ' Dieser Code wird von Visual Basic hinzugefügt, um das Dispose-Muster richtig zu implementieren.
    Public Sub Dispose() Implements IDisposable.Dispose
        ' Ändern Sie diesen Code nicht. Fügen Sie oben in Dispose(ByVal disposing As Boolean) Bereinigungscode ein.
        Dispose(True)
        GC.SuppressFinalize(Me)
    End Sub
#End Region

End Class
