﻿Imports System.Reflection

Module Hauptmodul

    Dim Kontakte(0 To 100) As Kontakt

    Sub Main()

        'Hier 'mal farbtechnisch was Anderes im Konsolenfenster
        Console.BackgroundColor = ConsoleColor.DarkRed
        Console.ForegroundColor = ConsoleColor.Black
        Console.Clear()

        'Zufallsadressen generieren
        Console.Write("Zufallsadressen werden generiert ... ")
        Dim kontakte = Kontakt.Zufallskontakte(100)
        Console.WriteLine("fertig!")
        Dim NachnameInfo As PropertyInfo = GetType(Kontakt).GetProperty("Nachname")
        Dim konListe = From konElement In kontakte Order By konElement.Nachname

        'Warten, bis das Programm beendet ist.
        Console.WriteLine()
        For Each konELement In konListe
            Console.WriteLine(konELement.Nachname)
        Next
        Console.WriteLine("Taste zum Beenden drücken...")
        Console.ReadKey()

    End Sub

    Sub AdressenAusgeben(ByVal von As Integer, ByVal bis As Integer)
        For c As Integer = von To bis
            Console.WriteLine(c.ToString("000") & ": " & Kontakte(c).KontaktText())
        Next
    End Sub

    'Lamda-Funktion nimmt zwei Kontakt-Objekte entgegen und liefert Integer zurück
    Sub AdressenSortieren(ByVal cDel As Func(Of Kontakt, Kontakt, Integer))

        Dim anzahlElemente As Integer = 101

        Dim aeussererZaehler As Integer
        Dim innererZaehler As Integer
        Dim delta As Integer

        Dim tempKontakt As Kontakt

        delta = 1

        'Größten Wert der Distanzfolge ermitteln
        Do
            delta = 3 * delta + 1
        Loop Until delta > anzahlElemente

        Do
            'Ist Abbruchkriterium - deswegen herunterzählen
            delta \= 3

            'Shellsort's Kernalgorithmus
            For aeussererZaehler = delta To anzahlElemente - 1
                tempKontakt = Kontakte(aeussererZaehler)

                innererZaehler = aeussererZaehler
                Do
                    'Invoke ist optional! - Es geht auch ohne:
                    If cDel(tempKontakt, Kontakte(innererZaehler - delta)) = 1 OrElse _
                        cDel(tempKontakt, Kontakte(innererZaehler - delta)) = 0 Then Exit Do
                    Kontakte(innererZaehler) = Kontakte(innererZaehler - delta)

                    innererZaehler = innererZaehler - delta
                    If (innererZaehler <= delta) Then Exit Do
                Loop
                Kontakte(innererZaehler) = tempKontakt
            Next
        Loop Until delta = 0
    End Sub
End Module
