﻿Imports System
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Media
Imports System.Windows.Shapes


Namespace TextKomplex
    Partial Public Class Window1
        Inherits System.Windows.Window
        Public Sub New()
            InitializeComponent()
            InitMyLayout()
        End Sub

        Private Sub InitMyLayout()
            Dim dock As New DockPanel

            Dim stack As New StackPanel
            stack.Orientation = Orientation.Horizontal
            stack.Height = 30

            Dim t1 As New TextBlock
            t1.FontSize = 20
            t1.Text = "Mit WPF"
            stack.Children.Add(t1)

            Dim e1 As New Ellipse
            e1.Width = 20
            e1.Fill = Brushes.Red
            stack.Children.Add(e1)

            Dim t2 As New TextBlock
            t2.Text = "kann man Grafik"
            t2.VerticalAlignment = Windows.VerticalAlignment.Center
            stack.Children.Add(t2)

            Dim r1 As New Rectangle
            r1.Width = 30
            r1.Fill = Brushes.Blue
            stack.Children.Add(r1)

            Dim t3 As New TextBlock
            t3.Text = "einfach mischen. Und einen"
            t3.VerticalAlignment = Windows.VerticalAlignment.Center
            stack.Children.Add(t3)

            Dim btn As New Button
            btn.Width = 120

            Dim pa As New StackPanel
            pa.Orientation = Orientation.Horizontal

            Dim ebtn1 As New Ellipse
            ebtn1.Width = 30
            ebtn1.Height = 10
            ebtn1.Fill = Brushes.Green
            ebtn1.Stroke = Brushes.Blue
            pa.Children.Add(ebtn1)

            Dim tbtn As New TextBlock
            tbtn.Text = "Hallo"
            pa.Children.Add(tbtn)

            Dim ebtn2 As New Ellipse
            ebtn2.Width = 30
            ebtn2.Height = 10
            ebtn2.Fill = Brushes.Red
            ebtn2.Stroke = Brushes.Blue
            pa.Children.Add(ebtn2)
            btn.Content = pa

            stack.Children.Add(btn)

            Dim t4 As New TextBlock
            t4.Text = "kann man auch einfügen."
            t4.VerticalAlignment = Windows.VerticalAlignment.Center
            stack.Children.Add(t4)

            Dim e2 As New Ellipse
            e2.Width = 30
            e2.Fill = Brushes.Yellow
            e2.Stroke = Brushes.Black
            stack.Children.Add(e2)

            dock.Children.Add(stack)
            Me.Content = dock
        End Sub
    End Class
End Namespace
